Date.Equals=function(expected,actual,reason){
    if(!Object.IsType(Date,expected))throw new Error("Date.Equals: 'expected' must be a valid Date.");
    if(!Object.IsType(Date,actual)){
        if(reason)reason.Value="Date.Equals: 'actual' was not a valid Date.";
        return false;
    }
    if(expected.getTime()!=actual.getTime()){
        if(reason)reason.Value=String.Format("Date.Equals: Dates did not match. Expected '{0}', found '{1}'.",expected,actual);
        return false;
    }
    return true;
};

Date.Format=function(date,formatString){
    if(!Object.IsType(Date,date))throw new Error("Date.Format: 'date' must be a valid Date.");
    if(!Object.IsType(Function,formatString&&formatString.toString))throw new Error("Date.Format: 'formatString' must implement toString().");
    switch(formatString){
        case 'd':
            return String.Format("{0}/{1}/{2}",date.getMonth()+1,date.getDate(),date.getFullYear());
        default:
            // Freeform format
            var format=formatString
                .replace(/yyyy/gm,'{0}')
                .replace(/yy/gm,'{1}')
                .replace(/MM/gm,'{2}')
                .replace(/M/gm,'{3}')
                .replace(/dd/gm,'{4}')
                .replace(/d/gm,'{5}')
                .replace(/hh/gm,'{6}')
                .replace(/h/gm,'{7}')
                .replace(/HH/gm,'{8}')
                .replace(/H/gm,'{9}')
                .replace(/mm/gm,'{10}')
                .replace(/m/gm,'{11}')
                .replace(/ss/gm,'{12}')
                .replace(/s/gm,'{13}')
                .replace(/tt/gm,'{14}')
                .replace(/ii/gm,'{15}')
                .replace(/i/gm,'{16}');
            var hours=date.getHours();
            var meridianHours=hours>0?hours>12?hours-12:hours:12;
            return String.Format(
                format,
                date.getFullYear(),
                String.Pad(date.getYear(),0,2),
                String.Pad(date.getMonth()+1,0,2),
                date.getMonth()+1,
                String.Pad(date.getDate(),0,2),
                date.getDate(),
                String.Pad(hours,0,2),
                hours,
                String.Pad(meridianHours,0,2),
                meridianHours,
                String.Pad(date.getMinutes(),0,2),
                date.getMinutes(),
                String.Pad(date.getSeconds(),0,2),
                date.getSeconds(),
                hours<12?'AM':'PM',
                String.Pad(date.getMilliseconds(),0,2),
                date.getMilliseconds()
            );
    }
};