Error.Equals=function(expected,actual,reason){
    if(!Object.IsType(Error,expected))throw new Error("Error.Equals: 'expected' must be a valid Error.");
    if(!Object.IsType(Error,actual)){
        if(reason)reason.Value="Error.Equals: 'actual' was not a valid Error.";
        return false;
    }
    var fields=["name","message","description","number","fileName"];
    for(var i=0;i<fields.length;i++){
        var field=fields[i];
        if(expected.hasOwnProperty(field)&&!Object.Equals(expected[field],actual[field])){
            if(reason)reason.Value=String.Format("Error.Equals: '{0}' did not match. Expected value '{1}', found '{2}'.",field,expected[field],actual[field]);
            return false;
        }
    }
    return true;
};

Error.IsEmpty=function(error){
    if(!Object.IsType(Error,error))throw new Error("Error.IsEmpty: 'error' must be a valid Error.");
    return String.IsEmpty(String.Trim(error));
};

Error.prototype.toString=function(verbose){
    var message=(this.hasOwnProperty("message")&&!String.IsEmpty(this.message)?this.message:this.description);
    if(message==undefined)message='';
    if(!Object.IsType(String,message))message=this+'';
    if(verbose){
        if(this.line)message=String.Format("{0}\n\t(line: {1})",message,this.line);
        if(this.lineNumber)message=String.Format("{0}\n\t(line: {1})",message,this.lineNumber);
        if(this.number)message=String.Format("{0}\n\t(number: {1})",message,this.number);
        if(this.stackTrace||this.stack||this.getStack)message=String.Format("{0}\n\tStackTrace: {1}",message,this.stackTrace||this.stack||this.getStack());
    }
    return message;
};